//+------------------------------------------------------------------+
//|                                                     Template.mq4 |
//|                                   Copyright 2016,                |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, "
#property link      ""
#property version   "1.00"
#property strict

#define MAGICMA  20150916

extern string Trades             = "  ";
extern double Lots               = 0.1;
extern int TakeProfit            = 20;
extern int StopLoss              = 20;
extern int TralLevel             = 20;
extern int Power_Slow            = 15;
extern bool UseTral              = true;

string Frames             = "    ";
int Main_TimeFrame        = 15; // 1-PERIOD_M1, 5-PERIOD_M5, 15-PERIOD_M15, 30-PERIOD_M30, 60-PERIOD_H1, 240-PERIOD_H4, 1440-PERIOD_D1, 10080-PERIOD_W1, 43200-PERIOD_MN1
int Slow_TimeFrame        = 30; // 1-PERIOD_M1, 5-PERIOD_M5, 15-PERIOD_M15, 30-PERIOD_M30, 60-PERIOD_H1, 240-PERIOD_H4, 1440-PERIOD_D1, 10080-PERIOD_W1, 43200-PERIOD_MN1

int GAP_Level=20;   //    10 
int GAP_TimeOUT                  = 10;
int GAP_Timer                    = 0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//----
   Main_TimeFrame=Period();
   switch(Main_TimeFrame)
     {
      case PERIOD_M1:
         Slow_TimeFrame=PERIOD_M5;
         break;
      case  PERIOD_M5:
         Slow_TimeFrame=PERIOD_M30;
         break;
      case PERIOD_M15:
         Slow_TimeFrame=PERIOD_H1;
         break;
      case PERIOD_M30:
         Slow_TimeFrame=PERIOD_H4;
         break;
      case PERIOD_H1:
         Slow_TimeFrame=PERIOD_D1;
         break;
      default:
         Slow_TimeFrame=Main_TimeFrame;
         break;
     }
   if(Digits==5 || Digits==3)
     {
      TakeProfit  *=10;
      StopLoss    *=10;
      GAP_Level   *=10;
      TralLevel   *=10;
      Power_Slow  *=10;
     }
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//----

//----
   return;
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void OnTick()
  {
//----
   if(Bars<100 || IsTradeAllowed()==false) return;
   if(isNewBar()==false) return;   //      - 
   if(CountVsego()==0) CheckForOpen();
   //else CheckForClose();
//----
   return;
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==symbol && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   //if(isNewBar()==false) return;   //      - 

   int res;

   int gap=(int)(MathAbs(Open[0]-Close[1])/Point);
   if(gap>GAP_Level) GAP_Timer=GAP_TimeOUT;

   if(GAP_Timer>0)
     {
      GAP_Timer--;
      if(GAP_Timer > 0) return;
     }

   if(Signal_Sell())
     {
     double stop = 2*iHigh(NULL,0,3)-iLow(NULL,0,1);
     double take = iOpen(NULL,0,0)-(iOpen(NULL,0,0)-stop)/2;
      //res=OrderSend(Symbol(),OP_SELL,Lots,Bid,5,Bid+StopLoss*Point,Bid-TakeProfit*Point,"",MAGICMA,0,Red);
      res=OrderSend(Symbol(),OP_SELL,Lots,Bid,5,stop,take,"",MAGICMA,0,Red);
      return;
     }
   if(Signal_Buy())
     {
     double stop = 2*iLow(NULL,0,3)-iHigh(NULL,0,1);
     double take = iOpen(NULL,0,0)+(iOpen(NULL,0,0)-stop)/2;
      //res=OrderSend(Symbol(),OP_BUY,Lots,Ask,5,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",MAGICMA,0,Blue);
      res=OrderSend(Symbol(),OP_BUY,Lots,Ask,5,stop,take,"",MAGICMA,0,Blue);
      return;
     }
  }
//+------------------------------------------------------------------+
bool Signal_Buy()
  {
   double op1 = iOpen(NULL,0,1);
   double op2 = iOpen(NULL,0,2);
   double op3 = iOpen(NULL,0,3);
   double cl1 = iClose(NULL,0,1);
   double cl2 = iClose(NULL,0,2);
   double cl3 = iClose(NULL,0,3);
   double wma56 = iMA(NULL, 0,56,0,MODE_LWMA,PRICE_CLOSE,1);
   double macd1 = iMACD(NULL, 0, 78,94,13,PRICE_CLOSE,MODE_SIGNAL,1);
   double macd2 = iMACD(NULL, 0, 78,94,13,PRICE_CLOSE,MODE_SIGNAL,2);
   if(op1<cl1 && op2<cl2 && op3<cl3 && cl3>wma56 && macd1>macd2)return(true);
   return(false);
  }
//+------------------------------------------------------------------+
bool Signal_Sell()
  {
   double op1 = iOpen(NULL,0,1);
   double op2 = iOpen(NULL,0,2);
   double op3 = iOpen(NULL,0,3);
   double cl1 = iClose(NULL,0,1);
   double cl2 = iClose(NULL,0,2);
   double cl3 = iClose(NULL,0,3);
   double wma56 = iMA(NULL, 0,56,0,MODE_LWMA,PRICE_CLOSE,1);
   double macd1 = iMACD(NULL, 0, 78,94,13,PRICE_CLOSE,MODE_SIGNAL,1);
   double macd2 = iMACD(NULL, 0, 78,94,13,PRICE_CLOSE,MODE_SIGNAL,2);
   if(op1>cl1 && op2>cl2 && op3>cl3 && cl3<wma56 && macd1<macd2)return(true);
   return(false);
  }
//+------------------------------------------------------------------+
void CheckForClose()
  {
//double SL,TP;
//int profit;
   //int temp1;
   bool res;
   for(int i=OrdersTotal()-1; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(UseTral)
           {
            if(Bid-OrderOpenPrice()>TralLevel*Point)
              {
               if(OrderStopLoss()<Bid-TralLevel*Point)
                 {
                  res=OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TralLevel*Point,OrderTakeProfit(),0,Green);
                 }
              }
           }
         else //  
           {
            if(OrderOpenPrice()<Bid-15*Point && OrderOpenPrice()>OrderStopLoss())
              {
               res=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+5*Point,OrderTakeProfit(),0,Blue);
               if(res==false)
                 {
                  Print("Error Modify BUY. Open = ",OrderOpenPrice()," Stop = ",OrderOpenPrice()+2*Point,
                        " Bid = ",Bid," Ask = ",Ask);
                 }
              }
           }
        }
      if(OrderType()==OP_SELL)
        {
         if(UseTral)
           {
            if((OrderOpenPrice()-Ask)>TralLevel*Point)
              {
               if((OrderStopLoss()>(Ask+TralLevel*Point)))
                 {
                  res=OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TralLevel*Point,OrderTakeProfit(),0,Red);
                 }
              }
           }
         else //  
           {
            if(OrderOpenPrice()>Ask+15*Point && OrderOpenPrice()<OrderStopLoss())
              {
               res=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-5*Point,OrderTakeProfit(),0,Red);
               if(res==false)
                 {
                  Print("Error Modify SELL. Open = ",OrderOpenPrice()," Stop = ",OrderOpenPrice()-2*Point,
                        " Ask = ",Ask," Bid = ",Bid);
                 }
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|  true,       /  |
//+------------------------------------------------------------------+
bool isNewBar()
  {
//---         
   static datetime last_time=0;
//---  
   datetime lastbar_time=(datetime)(SeriesInfoInteger(Symbol(),Period(),SERIES_LASTBAR_DATE));

//---     
   if(last_time==0)
     {
      //---     
      last_time=lastbar_time;
      return(false);
     }

//---   
   if(last_time!=lastbar_time)
     {
      //---     true
      last_time=lastbar_time;
      return(true);
     }
//---     -    ,  false
   return(false);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int CountSELL()
  {
   int count=0;
   int i;
   for(i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderType()==OP_SELL)
            count++;
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
int CountBUY()
  {
   int count=0;
   int i;
   for(i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderType()==OP_BUY)
            count++;
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CountVsego()
  {
   int Vsego;
   Vsego=CountBUY()+CountSELL();

   return(Vsego);
  }
//+------------------------------------------------------------------+